trap_ptr     .req    r11
alloc_ptr    .req    r8
alloc_limit  .req    r10
	.data
	.global	caml_startup__data_begin
caml_startup__data_begin:
	.text
	.global	caml_startup__code_begin
caml_startup__code_begin:
	.text
	.align	2
	.global	caml_program
caml_program:
	sub	sp, sp, #8
	str	lr, [sp, #4]
.L101:
.L102:  bl      camlPervasives__entry
	ldr	r3, .L103 @ caml_globals_inited
	ldr	r2, .L103 @ caml_globals_inited
	ldr     r1, [r2, #0]
	add     r0, r1, #1
	str     r0, [r3, #0]
.L104:  bl      camlEmpty__entry
	ldr	r12, .L103 @ caml_globals_inited
	ldr	r7, .L103 @ caml_globals_inited
	ldr     r6, [r7, #0]
	add     r5, r6, #1
	str     r5, [r12, #0]
.L105:  bl      camlStd_exit__entry
	ldr	r4, .L103 @ caml_globals_inited
	ldr	r3, .L103 @ caml_globals_inited
	ldr     r2, [r3, #0]
	add     r1, r2, #1
	str     r1, [r4, #0]
	mov	r0, #1
	ldr	lr, [sp, #4]
	add	sp, sp, #8
	bx	lr
.L103:        .word   caml_globals_inited
	.text
	.align	2
	.global	caml_curry4
caml_curry4:
	sub	sp, sp, #8
	str	lr, [sp, #4]
.L106:
	mov	r5, r0
	mov	r12, #20
	sub	alloc_ptr, alloc_ptr, r12
	cmp	alloc_ptr, alloc_limit
.L107:	blcc    caml_call_gc
	add	r0, alloc_ptr, #4
	mov	r2, #247 @ 4343
	add	r2, r2, #4096
	str     r2, [r0, #-4]
	ldr	r2, .L108 @ caml_curry4_1
	ldr	lr, [sp, #4]
	str     r2, [r0, #0]
	mov	r2, #3
	str     r2, [r0, #4]
	str     r5, [r0, #8]
	str     r1, [r0, #12]
	add	sp, sp, #8
	bx	lr
.L108:        .word   caml_curry4_1
	.text
	.align	2
	.global	caml_curry4_1
caml_curry4_1:
	sub	sp, sp, #8
	str	lr, [sp, #4]
.L109:
	mov	r5, r0
	mov	r12, #20
	sub	alloc_ptr, alloc_ptr, r12
	cmp	alloc_ptr, alloc_limit
.L110:	blcc    caml_call_gc
	add	r0, alloc_ptr, #4
	mov	r2, #247 @ 4343
	add	r2, r2, #4096
	str     r2, [r0, #-4]
	ldr	r2, .L111 @ caml_curry4_2
	ldr	lr, [sp, #4]
	str     r2, [r0, #0]
	mov	r2, #3
	str     r2, [r0, #4]
	str     r5, [r0, #8]
	str     r1, [r0, #12]
	add	sp, sp, #8
	bx	lr
.L111:        .word   caml_curry4_2
	.text
	.align	2
	.global	caml_curry4_2
caml_curry4_2:
	sub	sp, sp, #8
	str	lr, [sp, #4]
.L112:
	mov	r5, r0
	mov	r12, #20
	sub	alloc_ptr, alloc_ptr, r12
	cmp	alloc_ptr, alloc_limit
.L113:	blcc    caml_call_gc
	add	r0, alloc_ptr, #4
	mov	r2, #247 @ 4343
	add	r2, r2, #4096
	str     r2, [r0, #-4]
	ldr	r2, .L114 @ caml_curry4_3
	ldr	lr, [sp, #4]
	str     r2, [r0, #0]
	mov	r2, #3
	str     r2, [r0, #4]
	str     r5, [r0, #8]
	str     r1, [r0, #12]
	add	sp, sp, #8
	bx	lr
.L114:        .word   caml_curry4_3
	.text
	.align	2
	.global	caml_curry4_3
caml_curry4_3:
.L115:
	ldr     r7, [r1, #12]
	ldr     r2, [r1, #8]
	ldr     r6, [r7, #12]
	ldr     r1, [r7, #8]
	ldr     r4, [r6, #12]
	mov	r3, r0
	ldr     r5, [r4, #8]
	ldr     r0, [r6, #8]
	bx	r5
	.text
	.align	2
	.global	caml_curry3
caml_curry3:
	sub	sp, sp, #8
	str	lr, [sp, #4]
.L116:
	mov	r5, r0
	mov	r12, #20
	sub	alloc_ptr, alloc_ptr, r12
	cmp	alloc_ptr, alloc_limit
.L117:	blcc    caml_call_gc
	add	r0, alloc_ptr, #4
	mov	r2, #247 @ 4343
	add	r2, r2, #4096
	str     r2, [r0, #-4]
	ldr	r2, .L118 @ caml_curry3_1
	ldr	lr, [sp, #4]
	str     r2, [r0, #0]
	mov	r2, #3
	str     r2, [r0, #4]
	str     r5, [r0, #8]
	str     r1, [r0, #12]
	add	sp, sp, #8
	bx	lr
.L118:        .word   caml_curry3_1
	.text
	.align	2
	.global	caml_curry3_1
caml_curry3_1:
	sub	sp, sp, #8
	str	lr, [sp, #4]
.L119:
	mov	r5, r0
	mov	r12, #20
	sub	alloc_ptr, alloc_ptr, r12
	cmp	alloc_ptr, alloc_limit
.L120:	blcc    caml_call_gc
	add	r0, alloc_ptr, #4
	mov	r2, #247 @ 4343
	add	r2, r2, #4096
	str     r2, [r0, #-4]
	ldr	r2, .L121 @ caml_curry3_2
	ldr	lr, [sp, #4]
	str     r2, [r0, #0]
	mov	r2, #3
	str     r2, [r0, #4]
	str     r5, [r0, #8]
	str     r1, [r0, #12]
	add	sp, sp, #8
	bx	lr
.L121:        .word   caml_curry3_2
	.text
	.align	2
	.global	caml_curry3_2
caml_curry3_2:
.L122:
	ldr     r4, [r1, #12]
	mov	r2, r0
	ldr     r3, [r4, #12]
	ldr     r0, [r4, #8]
	ldr     r4, [r3, #8]
	ldr     r1, [r1, #8]
	bx	r4
	.text
	.align	2
	.global	caml_curry2
caml_curry2:
	sub	sp, sp, #8
	str	lr, [sp, #4]
.L123:
	mov	r5, r0
	mov	r12, #20
	sub	alloc_ptr, alloc_ptr, r12
	cmp	alloc_ptr, alloc_limit
.L124:	blcc    caml_call_gc
	add	r0, alloc_ptr, #4
	mov	r2, #247 @ 4343
	add	r2, r2, #4096
	str     r2, [r0, #-4]
	ldr	r2, .L125 @ caml_curry2_1
	ldr	lr, [sp, #4]
	str     r2, [r0, #0]
	mov	r2, #3
	str     r2, [r0, #4]
	str     r5, [r0, #8]
	str     r1, [r0, #12]
	add	sp, sp, #8
	bx	lr
.L125:        .word   caml_curry2_1
	.text
	.align	2
	.global	caml_curry2_1
caml_curry2_1:
.L126:
	ldr     r2, [r1, #12]
	mov	r4, r0
	ldr     r3, [r2, #8]
	ldr     r0, [r1, #8]
	mov	r1, r4
	bx	r3
	.text
	.align	2
	.global	caml_apply3
caml_apply3:
	sub	sp, sp, #16
	str	lr, [sp, #12]
.L128:
	ldr     r4, [r3, #4]
	cmp	r4, #7
	bne	.L127
	ldr     r4, [r3, #8]
	ldr	lr, [sp, #12]
	add	sp, sp, #16
	bx	r4
.L127:
	str	r2, [sp, #4]
	ldr     r2, [r3, #0]
	str	r1, [sp, #0]
	mov	r1, r3
	mov	lr, pc
.L129:  bx	r2
	mov	r1, r0
	ldr     r7, [r1, #0]
	ldr	r0, [sp, #0]
	mov	lr, pc
.L130:  bx	r7
	mov	r1, r0
	ldr     r5, [r1, #0]
	ldr	r0, [sp, #4]
	ldr	lr, [sp, #12]
	add	sp, sp, #16
	bx	r5
	.text
	.align	2
	.global	caml_apply2
caml_apply2:
	sub	sp, sp, #8
	str	lr, [sp, #4]
.L132:
	ldr     r5, [r2, #4]
	cmp	r5, #5
	bne	.L131
	ldr     r3, [r2, #8]
	ldr	lr, [sp, #4]
	add	sp, sp, #8
	bx	r3
.L131:
	ldr     r4, [r2, #0]
	str	r1, [sp, #0]
	mov	r1, r2
	mov	lr, pc
.L133:  bx	r4
	mov	r1, r0
	ldr     r2, [r1, #0]
	ldr	r0, [sp, #0]
	ldr	lr, [sp, #4]
	add	sp, sp, #8
	bx	r2
	.data
	.global	caml_exn_Out_of_memory
	.word	1024
caml_exn_Out_of_memory:
	.word	.L100001
	.word	4348
.L100001:
	.ascii  "Out_of_memory"
	.space	2
	.byte	2
	.global	caml_bucket_Out_of_memory
	.word	1024
caml_bucket_Out_of_memory:
	.word	caml_exn_Out_of_memory
	.data
	.global	caml_exn_Sys_error
	.word	1024
caml_exn_Sys_error:
	.word	.L100002
	.word	3324
.L100002:
	.ascii  "Sys_error"
	.space	2
	.byte	2
	.global	caml_bucket_Sys_error
	.word	1024
caml_bucket_Sys_error:
	.word	caml_exn_Sys_error
	.data
	.global	caml_exn_Failure
	.word	1024
caml_exn_Failure:
	.word	.L100003
	.word	2300
.L100003:
	.ascii  "Failure"
	.byte	0
	.global	caml_bucket_Failure
	.word	1024
caml_bucket_Failure:
	.word	caml_exn_Failure
	.data
	.global	caml_exn_Invalid_argument
	.word	1024
caml_exn_Invalid_argument:
	.word	.L100004
	.word	5372
.L100004:
	.ascii  "Invalid_argument"
	.space	3
	.byte	3
	.global	caml_bucket_Invalid_argument
	.word	1024
caml_bucket_Invalid_argument:
	.word	caml_exn_Invalid_argument
	.data
	.global	caml_exn_End_of_file
	.word	1024
caml_exn_End_of_file:
	.word	.L100005
	.word	3324
.L100005:
	.ascii  "End_of_file"
	.byte	0
	.global	caml_bucket_End_of_file
	.word	1024
caml_bucket_End_of_file:
	.word	caml_exn_End_of_file
	.data
	.global	caml_exn_Division_by_zero
	.word	1024
caml_exn_Division_by_zero:
	.word	.L100006
	.word	5372
.L100006:
	.ascii  "Division_by_zero"
	.space	3
	.byte	3
	.global	caml_bucket_Division_by_zero
	.word	1024
caml_bucket_Division_by_zero:
	.word	caml_exn_Division_by_zero
	.data
	.global	caml_exn_Not_found
	.word	1024
caml_exn_Not_found:
	.word	.L100007
	.word	3324
.L100007:
	.ascii  "Not_found"
	.space	2
	.byte	2
	.global	caml_bucket_Not_found
	.word	1024
caml_bucket_Not_found:
	.word	caml_exn_Not_found
	.data
	.global	caml_exn_Match_failure
	.word	1024
caml_exn_Match_failure:
	.word	.L100008
	.word	4348
.L100008:
	.ascii  "Match_failure"
	.space	2
	.byte	2
	.global	caml_bucket_Match_failure
	.word	1024
caml_bucket_Match_failure:
	.word	caml_exn_Match_failure
	.data
	.global	caml_exn_Stack_overflow
	.word	1024
caml_exn_Stack_overflow:
	.word	.L100009
	.word	4348
.L100009:
	.ascii  "Stack_overflow"
	.space	1
	.byte	1
	.global	caml_bucket_Stack_overflow
	.word	1024
caml_bucket_Stack_overflow:
	.word	caml_exn_Stack_overflow
	.data
	.global	caml_exn_Sys_blocked_io
	.word	1024
caml_exn_Sys_blocked_io:
	.word	.L100010
	.word	4348
.L100010:
	.ascii  "Sys_blocked_io"
	.space	1
	.byte	1
	.global	caml_bucket_Sys_blocked_io
	.word	1024
caml_bucket_Sys_blocked_io:
	.word	caml_exn_Sys_blocked_io
	.data
	.global	caml_exn_Assert_failure
	.word	1024
caml_exn_Assert_failure:
	.word	.L100011
	.word	4348
.L100011:
	.ascii  "Assert_failure"
	.space	1
	.byte	1
	.global	caml_bucket_Assert_failure
	.word	1024
caml_bucket_Assert_failure:
	.word	caml_exn_Assert_failure
	.data
	.global	caml_exn_Undefined_recursive_module
	.word	1024
caml_exn_Undefined_recursive_module:
	.word	.L100012
	.word	7420
.L100012:
	.ascii  "Undefined_recursive_module"
	.space	1
	.byte	1
	.global	caml_bucket_Undefined_recursive_module
	.word	1024
caml_bucket_Undefined_recursive_module:
	.word	caml_exn_Undefined_recursive_module
	.data
	.global	caml_globals
caml_globals:
	.word	camlPervasives
	.word	camlEmpty
	.word	camlStd_exit
	.word	0
	.data
	.global	caml_globals_map
	.word	43260
caml_globals_map:
	.ascii  "\204\225\246\276\0\0\0\223\0\0\0\22\0\0\0P\0\0\0A\240\300*Pervasives0\333r:\27\230\261\42\340\211\31\242\277\355\6%\24\60n\330\251\5sof\36\343\330\201\320^A\333B\240\4\4@\240\300%Empty0"
	.ascii  "MS,\32\245\223\250\250w/\301\245}b\314\1\60\300\244%O\203\357\65\340|T\42\366\317\355\214R\240\4\4@\240\300(Std_exit0K<u\217\27kw\366\203\3\37W\376u\277\312\60\363\263\334I\15\332\251\1\230\27\235V\245d"
	.ascii  "kK\240\4\4@@"
	.byte	0
	.data
	.global	caml_data_segments
caml_data_segments:
	.word	caml_startup__data_begin
	.word	caml_startup__data_end
	.word	camlPervasives__data_begin
	.word	camlPervasives__data_end
	.word	camlEmpty__data_begin
	.word	camlEmpty__data_end
	.word	camlStd_exit__data_begin
	.word	camlStd_exit__data_end
	.word	0
	.data
	.global	caml_code_segments
caml_code_segments:
	.word	caml_startup__code_begin
	.word	caml_startup__code_end
	.word	camlPervasives__code_begin
	.word	camlPervasives__code_end
	.word	camlEmpty__code_begin
	.word	camlEmpty__code_end
	.word	camlStd_exit__code_begin
	.word	camlStd_exit__code_end
	.word	0
	.data
	.global	caml_frametable
caml_frametable:
	.word	caml_startup__frametable
	.word	caml_system__frametable
	.word	camlPervasives__frametable
	.word	camlEmpty__frametable
	.word	camlStd_exit__frametable
	.word	0
	.text
	.global	caml_startup__code_end
caml_startup__code_end:
	.data
	.global	caml_startup__data_end
caml_startup__data_end:
	.word	0
	.data
	.global	caml_startup__frametable
caml_startup__frametable:
	.word	12
	.word	.L133 + 4
	.short	8
	.short	1
	.short	0
	.align	2
	.word	.L130 + 4
	.short	16
	.short	1
	.short	4
	.align	2
	.word	.L129 + 4
	.short	16
	.short	2
	.short	0
	.short	4
	.align	2
	.word	.L124 + 4
	.short	8
	.short	2
	.short	3
	.short	11
	.align	2
	.word	.L120 + 4
	.short	8
	.short	2
	.short	3
	.short	11
	.align	2
	.word	.L117 + 4
	.short	8
	.short	2
	.short	3
	.short	11
	.align	2
	.word	.L113 + 4
	.short	8
	.short	2
	.short	3
	.short	11
	.align	2
	.word	.L110 + 4
	.short	8
	.short	2
	.short	3
	.short	11
	.align	2
	.word	.L107 + 4
	.short	8
	.short	2
	.short	3
	.short	11
	.align	2
	.word	.L105 + 4
	.short	8
	.short	0
	.align	2
	.word	.L104 + 4
	.short	8
	.short	0
	.align	2
	.word	.L102 + 4
	.short	8
	.short	0
	.align	2
